/***

mMonkeyEntry - DUIS-Standardframe.m
by Leechbite

standardframe script for the DUI interface.

***/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"
#include "dui-utilities.m"

function setNewGroup(String groupid);
function setToDUIMode();
function resetFromDUIMode();
function syncFrame();

Global Group frameGroup, content, titlebar;
Global layout frameLayout;
Global Container frameContainer;
Global String x, y, w, h, rx, ry, rw, rh;
Global String min_w, min_h, max_w, max_h;
Global Layer mouselayer;
Global Button Sysmenu;

global container duiMainContainer;
global layout duiMainLayout;
global group duiMainGroup;
global guiObject duiMainWin;
global timer delaySync;

Global String duix, duiy, duiw, duih;

global text titleText;
global ConfigAttribute currwindow_attach_attrib;
global guiObject concealer, duiFrame;
global string duiWindow; // determines to which DUI-window the skin shows. set from param=""
global string windowName;
global boolean localClose = FALSE;
global boolean localFocus = FALSE;
global boolean lastFocus = FALSE;
global boolean localResize = FALSE;

global boolean allLoaded = FALSE;
global boolean mainMove = FALSE;

global button attachButton;
global button detachButton;

System.onScriptLoaded() {
  initAttribs();
	
  frameGroup = getScriptGroup();
  frameLayout = frameGroup.getParentLayout();
  frameContainer = frameLayout.getContainer();
  String param = getParam();
  x = getToken(param, ",", 0);
  y = getToken(param, ",", 1);
  w = getToken(param, ",", 2);
  h = getToken(param, ",", 3);
  rx = getToken(param, ",", 4);
  ry = getToken(param, ",", 5);
  rw = getToken(param, ",", 6);
  rh = getToken(param, ",", 7);
  
  min_w = frameLayout.getXMLParam("minimum_w");
  min_h = frameLayout.getXMLParam("minimum_h");
  max_w = frameLayout.getXMLParam("maximum_w");
  max_h = frameLayout.getXMLParam("maximum_h");
  
  group temp = frameGroup.findObject("attach");
  attachButton = temp.getObject("xui.button");
  temp = frameGroup.findObject("dui.detach");
  detachButton = temp.getObject("xui.button");
  
  duiWindow = strlower(getToken(param, ",", 8));
  sysmenu = frameGroup.findObject("sysmenu");
  concealer = frameGroup.findObject("dui.concealer");
  duiFrame = frameGroup.findObject("dui.frame");
  concealer.show();
  duiFrame.hide();
  
  duix = getToken(param, ",", 9);
  duiy = getToken(param, ",", 10);
  duiw = getToken(param, ",", 11);
  duih = getToken(param, ",", 12);
  
  delaySync = new Timer;
  delaySync.setDelay(1);
  
  titleText = frameGroup.findObject("titlebar");
}

// **** DUI scripts
system.onScriptUnloading() {
  duiMainContainer = NULL;
  duiMainLayout = NULL;
  duiMainGroup = NULL;
  duiMainWin = NULL;

  if ((currwindow_attach_attrib != NULL) && (!localClose)) {
	if (currwindow_attach_attrib.getData()=="1") sendDUICommand(windowName, CLOSE_DUI_WINDOW, duiWindow);
  }
}

frameLayout.onSetVisible(boolean on) {
  if (!on) {
	duiMainContainer = NULL;
    duiMainLayout = NULL;
    duiMainGroup = NULL;
    duiMainWin = NULL;
    if ((currwindow_attach_attrib != NULL) && (!localClose)) {
	  if (currwindow_attach_attrib.getData()=="1") sendDUICommand(windowName, CLOSE_DUI_WINDOW, duiWindow);
    }
  } else {
	if (strleft(titleText.getText(),1)!=":") titleText.onTextChanged(titleText.getText());
  }
}

titleText.onTextChanged(string newTitle) {
  if (strleft(newTitle,1)!=":") {
    sendDUICommand(newTitle, ADD_TO_DUI_LIST, "");
    currwindow_attach_attrib = custom_page_windows.newAttribute("Attach "+newTitle+" window", "1");

    windowName = newTitle;
    if (currwindow_attach_attrib.getData()=="1") {
	  concealer.show();
	  sendDUICommand(windowName, OPEN_DUI_REQUEST, duiWindow+","+min_w+","+min_h+","+max_w+","+max_h);
    } else {
	  concealer.hide();
	  frameLayout.setFocus();
    }
    
    allLoaded = TRUE;
  }
}

currwindow_attach_attrib.onDataChanged() {
  if (getData()=="0") {
	concealer.hide();
    sendDUICommand(windowName, DETACH_WINDOW_REQUEST, duiWindow);
    
    frameLayout.resize( getPrivateInt(getSkinName(),windowName+"Last X", 0), 
    					getPrivateInt(getSkinName(),windowName+"Last Y", 0), 
    					getPrivateInt(getSkinName(),windowName+"Last W", stringToInteger(max_w)), 
    					getPrivateInt(getSkinName(),windowName+"Last H", stringToInteger(max_h))); 
  } else {
    setPrivateInt(getSkinName(),windowName+"Last X", frameLayout.getLeft());
    setPrivateInt(getSkinName(),windowName+"Last Y", frameLayout.getTop());
    setPrivateInt(getSkinName(),windowName+"Last W", frameLayout.getWidth());
    setPrivateInt(getSkinName(),windowName+"Last H", frameLayout.getHeight());

	concealer.show();
	sendDUICommand(windowName, OPEN_DUI_REQUEST, duiWindow+","+min_w+","+min_h+","+max_w+","+max_h);
  }
}

attachButton.onLeftClick() {
  if (currwindow_attach_attrib) currwindow_attach_attrib.setData("1");
}

detachButton.onLeftClick() {
  if (currwindow_attach_attrib) currwindow_attach_attrib.setData("0");
}

onReceiveDUICommand(string winName, string command, string param) {
  string lowWinName = strlower(winName);
  string lowWinName2 = strlower(windowName);
  if (lowWinName == lowWinName2) return;
  
  string param1 = strlower(gettoken(param,",",0));

  if (winName == MAINID) {

    if (command == OPEN_DUI_GRANTED) {
	  if (currwindow_attach_attrib) { if (currwindow_attach_attrib.getData()=="0") return; }  
	  if (param1 == "all") param1 = strlower(windowName);
	  if (param1 == strlower(windowName)){
	  
        string duiContainerID = strlower(gettoken(param,",",1));
        string duiLayoutID = strlower(gettoken(param,",",2));
        string duiGroupID = strlower(gettoken(param,",",3));
        string duiWinID = strlower(gettoken(param,",",4));
        
        duiMainContainer = getContainer(duiContainerID);
        if (duiMainContainer) duiMainLayout = duiMainContainer.getLayout(duiLayoutID);
        if (duiMainLayout) duiMainGroup = duiMainLayout.findObject(duiGroupID);
        if (duiMainGroup) duiMainWin = duiMainGroup.findObject(duiWinID);
        
        delaySync.start();
        setToDUIMode();
	    concealer.hide();
      }
    } else if (command == DETACH_WINDOW_GRANTED) {
      if (param1 == "all") param1 = strlower(windowName);
	  if (param1 == strlower(windowName)) {
	    resetFromDUIMode();
	    concealer.hide();
      }
    } else if (command == CLOSE_DUI_WINDOW) {
	  if (currwindow_attach_attrib) { if (currwindow_attach_attrib.getData()=="0") return; } 
	  if (param1 == "all") param1 = strlower(windowName);
  	  if (param1 == strlower(windowName)) {
	  	localClose = 1;
        system.triggerAction(frameLayout,"close","");
        localClose = 0;
      }
    }
  }

  if (command == SET_FOCUS) {
	  if (currwindow_attach_attrib) { if (currwindow_attach_attrib.getData()=="0") return; } 
	  if (param1 == "all") param1 = strlower(windowName);
  	  if (param1 == strlower(windowName)) {
	    localFocus = TRUE;
	    frameLayout.setFocus();
       }
  }
}

delaySync.onTimer() {
  stop();
  if (duiMainGroup) syncFrame();
}


frameLayout.onResize(int wx, int wy, int ww, int wh) {
  if (localResize) return;
  if (duiMainLayout == NULL) return;
  if (currwindow_attach_attrib.getData()!="1") return;
  
  int newMainWidth  = (ww - duiMainWin.getWidth()) + duiMainLayout.getWidth();
  int newMainHeight  = (wh - duiMainWin.getHeight()) + duiMainLayout.getHeight();
  
  localResize = TRUE;
  duiMainLayout.resize(duiMainLayout.getLeft(), duiMainLayout.getTop(), newMainWidth, newMainHeight);
  localResize = FALSE;
}

syncFrame() {
  localResize = TRUE;
  if (duiMainWin) {
	frameLayout.setScale(duiMainLayout.getScale());
    frameLayout.resize(duiMainWin.clientToScreenX(duiMainWin.getLeft()), duiMainWin.clientToScreenY(duiMainWin.getTop()),
    					duiMainWin.getWidth(),duiMainWin.getHeight());
    					
    // double checks if it allowed the resizing, if not resize back the main window.
    if ((frameLayout.getWidth() != duiMainWin.getWidth()) || (frameLayout.getHeight() != duiMainWin.getHeight())) {
      localResize = FALSE;
      
      frameLayout.onResize(duiMainWin.clientToScreenX(duiMainWin.getLeft()), duiMainWin.clientToScreenY(duiMainWin.getTop()),
      				 frameLayout.getWidth(), frameLayout.getHeight());
    }
  }
  localResize = FALSE;
}

duiMainWin.onResize(int wx, int wy, int ww, int wh) {
  if (!currwindow_attach_attrib) return;
  if (currwindow_attach_attrib.getData()!="1") return;
  if (concealer.isVisible()) return;
	
  syncFrame();
}

duiMainLayout.onMove() {
  mainMove = TRUE;
  
  if (!currwindow_attach_attrib) return;
  if (currwindow_attach_attrib.getData()!="1") return;
  if (concealer.isVisible()) return;

  syncFrame();
  mainMove = FALSE;
}

duiMainLayout.onSetVisible(boolean on) {
  if (!currwindow_attach_attrib) return;
  if (currwindow_attach_attrib.getData()!="1") return;
  if (concealer.isVisible()) return;
  
  localClose = 1;
  system.triggerAction(frameLayout,"close","");
  localClose = 0;  
}

// attrib toggles every 0.1 sec
genTimerAttrib.onDataChanged() {

  if (!allLoaded) return;
  if (!currwindow_attach_attrib) return;
  if (currwindow_attach_attrib.getData()!="1") return;
  if (concealer.isVisible()) return;
  	
  syncFrame();
  
  // ** focusing scripts
  if (localFocus) { localFocus = FALSE; return; }
  if (windowName == "") return;

    if ((lastFocus == FALSE) && (frameLayout.isActive())) {
    sendDUICommand(windowName, SET_FOCUS, "all");
    frameLayout.setFocus();	

  }
  lastFocus = frameLayout.isActive();
}

frameLayout.onMove() {
  if (mainMove) return;
  if (!allLoaded) return;
  if (!currwindow_attach_attrib) return;
  if (currwindow_attach_attrib.getData()!="1") return;
  if (concealer.isVisible()) return;

  syncFrame();
}

setToDUIMode() {
  duiFrame.show();
  
  frameLayout.setXMLParam("minimum_w","10");
  frameLayout.setXMLParam("minimum_h","10");

  if (content) {
    content.setXmlParam("x", duix);
    content.setXmlParam("y", duiy);
    content.setXmlParam("w", duiw);
    content.setXmlParam("h", duih);
  }
}

resetFromDUIMode() {
  duiFrame.hide();
  
  frameLayout.setXMLParam("minimum_w",min_w);
  frameLayout.setXMLParam("minimum_h",min_h);

  
  if (content) {
    content.setXmlParam("x", x);
    content.setXmlParam("y", y);
    content.setXmlParam("w", w);
    content.setXmlParam("h", h);
    content.setXmlParam("relatx", rx);
    content.setXmlParam("relaty", ry);
    content.setXmlParam("relatw", rw);
    content.setXmlParam("relath", rh);
  }
}

frameLayout.onGetFocus() {
  //setTempText("Focus|"+windowName);
  if (localFocus) return;
  if (windowName == "") return;
  if (dui_last_focus.getData() == strlower(windowName)) return;
  
  sendDUICommand(windowName, SET_FOCUS, "all");
  dui_last_focus.setData(strlower(windowName));
  frameLayout.setFocus();
  
}

// **** regular standard-frame scripts **********

System.onSetXuiParam(String param, String value) {
  if (param == "content") {
    setNewGroup(value);
    titlebar = frameGroup.findObject("wasabi.titlebar");
    mouselayer = titlebar.findObject("mousetrap");
  }
  if (param == "padtitleright" || param == "padtitleleft") {
    if (titlebar != NULL) titlebar.setXmlParam(param, value); 
  }
  if (param == "shade") {
    if (mouselayer != NULL) mouselayer.setXmlParam("dblclickaction", "switch;"+value);
    else messagebox("Cannot set shade parameter for StandardFrame object, no mousetrap found", "Skin Error", 0, "");
  }
}

// backward compatibility for prerelease notify trick
frameGroup.onNotify(String cmd, String param, int a, int b) {
  String _command = getToken(cmd, ",", 0);
  String _param = getToken(cmd, ",", 1);
  if (_command == "content" || _command == "padtitleright" || _command == "padtitleleft" || _command == "shade") {
    onSetXuiParam(_command, _param);
  }
}

setNewGroup(String groupid) {
  content = newGroup(groupid);
  if (content == NULL) {
    messagebox("group \"" + groupid + "\" not found", "ButtonGroup", 0, "");
    return;
  }
  
  content.setXmlParam("x", x);
  content.setXmlParam("y", y);
  content.setXmlParam("w", w);
  content.setXmlParam("h", h);
  
  if (currwindow_attach_attrib) {
    if (currwindow_attach_attrib.getData()=="1") {
      content.setXmlParam("x", duix);
      content.setXmlParam("y", duiy);
      content.setXmlParam("w", duiw);
      content.setXmlParam("h", duih);
    }
  }
  content.setXmlParam("relatx", rx);
  content.setXmlParam("relaty", ry);
  content.setXmlParam("relatw", rw);
  content.setXmlParam("relath", rh);
  content.init(frameGroup);
}

Sysmenu.onLeftClick() {
  LayoutStatus _status = frameGroup.findObject("sysmenu.status");
  _status.callme("{system}");
}
