#ifndef included
#error This script can only be compiled as a #include
#endif

#ifndef __ATTRIBS_M
#define __ATTRIBS_M

#include <lib/config.mi>

// -----------------------------------------------------------------------------------------------------------------

// this is the page that maps its items to the options menu, you can add attribs or more pages (submenus)
#define CUSTOM_OPTIONSMENU_ITEMS "{1828D28F-78DD-4647-8532-EBA504B8FC04}"

// this is the page that maps its items to the windows menu (aka View), you can add attribs or more pages (submenus)
#define CUSTOM_WINDOWSMENU_ITEMS "{6559CA61-7EB2-4415-A8A9-A2AEEF762B7F}"

// custom options submenu item page, you can add more, just use guidgen and Config.newItem()
#define CUSTOM_PAGE "{26E26319-AECA-4433-B8F1-F4A5BF2A9ED5}"

// windows config page
#define CUSTOM_PAGE_WINDOWS "{5E13F556-4221-4192-BC01-A94059CAD298}"

// notifier config page
#define CUSTOM_PAGE_NOTIFIER "{1AB968B3-8687-4a35-BA70-FCF6D92FB57F}"

// non exposed attribs page
#define CUSTOM_PAGE_NONEXPOSED "{E9C2D926-53CA-400f-9A4D-85E31755A4CF}"


// -----------------------------------------------------------------------------------------------------------------

Function initAttribs();
function boolean onTempText(); // returns TRUE is songticker is still on TempText

// -----------------------------------------------------------------------------------------------------------------
Global ConfigItem custom_page_windows; // <-- make this global because its being used by other DUI-scripts..

Global ConfigAttribute windows_pl_attrib;
Global ConfigAttribute windows_ml_attrib;
Global ConfigAttribute windows_vid_attrib;
Global ConfigAttribute windows_avs_attrib;

Global ConfigAttribute notifier_minimized_attrib;
Global ConfigAttribute notifier_windowshade_attrib;
Global ConfigAttribute notifier_always_attrib;
Global ConfigAttribute notifier_never_attrib;
Global ConfigAttribute notifier_fadeintime_attrib;
Global ConfigAttribute notifier_fadeouttime_attrib;
Global ConfigAttribute notifier_holdtime_attrib;
Global ConfigAttribute notifier_disablefullscreen_attrib;
Global ConfigAttribute notifier_showend_attrib;

Global ConfigAttribute notifier_location_topright_attrib;
Global ConfigAttribute notifier_location_topleft_attrib;
Global ConfigAttribute notifier_location_bottomright_attrib;
Global ConfigAttribute notifier_location_bottomleft_attrib;

Global ConfigAttribute notifier_cdcover_attrib;

Global ConfigAttribute temptext_attrib;
Global ConfigAttribute ontemptext_attrib;

Global ConfigAttribute dui_comm_attrib;
Global ConfigAttribute dui_win_main_content_attrib;
Global ConfigAttribute dui_win_main2_content_attrib;
Global ConfigAttribute dui_win_side_content_attrib;
Global ConfigAttribute dui_win_side2_content_attrib;
Global ConfigAttribute dui_last_focus;

Global ConfigAttribute genTimerAttrib;
Global Timer genTimer;

Global ConfigAttribute aot_attrib;


// -----------------------------------------------------------------------------------------------------------------

initAttribs() {

	// create the custom cfgpage for this session (if it does exist, it just returns it)
	ConfigItem custom_page = Config.newItem("mMonkey", CUSTOM_PAGE);
	custom_page_windows = Config.newItem("Windows", CUSTOM_PAGE_WINDOWS);
	ConfigItem custom_page_notifier = Config.newItem("Notifications", CUSTOM_PAGE_NOTIFIER);

	ConfigItem custom_page_nonexposed = Config.newItem("Hidden", CUSTOM_PAGE_NONEXPOSED);

	// load up the cfgpage in which we'll insert our custom page
	ConfigItem custom_options_page = Config.getItem(CUSTOM_OPTIONSMENU_ITEMS);
	ConfigItem custom_windows_page = Config.getItem(CUSTOM_WINDOWSMENU_ITEMS);

	// this creates a submenu for this attribute
	ConfigAttribute submenuattrib = custom_options_page.newAttribute("mMonkey", "");
	submenuattrib.setData(CUSTOM_PAGE); // discard any default value and point at our custom cfgpage

	ConfigAttribute windowssubmenu = custom_page.newAttribute("Windows", "");
	windowssubmenu.setData(CUSTOM_PAGE_WINDOWS);
	
	ConfigAttribute notifiersubmenu = custom_page.newAttribute("Notifications", "");
	notifiersubmenu.setData(CUSTOM_PAGE_NOTIFIER);

	ConfigAttribute sep,sep2;

	// create an attribute for each of our options, if the attribute already exists, it is returned
	sep = custom_page.newAttribute("sep1", ""); sep.setData("-");

	windows_pl_attrib = custom_page_windows.newAttribute("Attach Playlist Editor window", "1");
	windows_ml_attrib = custom_page_windows.newAttribute("Attach Media Library window", "1");
	windows_vid_attrib = custom_page_windows.newAttribute("Attach Video window", "1");
	windows_avs_attrib = custom_page_windows.newAttribute("Attach Visualizations window", "1");

	notifier_always_attrib = custom_page_notifier.newAttribute("Show always", "0");
	notifier_windowshade_attrib = custom_page_notifier.newAttribute("Show with stick, shade and when minimized", "0");
	notifier_minimized_attrib = custom_page_notifier.newAttribute("Show only when minimized", "0");
	notifier_never_attrib = custom_page_notifier.newAttribute("Never show", "1");
	sep = custom_page_notifier.newAttribute("sep1", ""); sep.setData("-");
	notifier_location_topright_attrib = custom_page_notifier.newAttribute("Location: Top Right", "0");
	notifier_location_topleft_attrib = custom_page_notifier.newAttribute("Location: Top Left", "0");
	notifier_location_bottomright_attrib = custom_page_notifier.newAttribute("Location: Bottom Right", "1");
	notifier_location_bottomleft_attrib = custom_page_notifier.newAttribute("Location: Bottom Left", "0");
	sep = custom_page_notifier.newAttribute("sep2", ""); sep.setData("-");
	notifier_cdcover_attrib = custom_page_notifier.newAttribute("Show CD Cover", "0");
	notifier_disablefullscreen_attrib = custom_page_notifier.newAttribute("Disable in fullscreen", "1");
	notifier_showend_attrib = custom_page_notifier.newAttribute("Show again at end of track", "1");

	notifier_fadeintime_attrib = custom_page_nonexposed.newAttribute("Notifications fade in time", "1000");
	notifier_fadeouttime_attrib = custom_page_nonexposed.newAttribute("Notifications fade out time", "5000");
	notifier_holdtime_attrib = custom_page_nonexposed.newAttribute("Notifications display time", "2000");

	
	// *** Other attribs
	temptext_attrib = custom_page_nonexposed.newAttribute("Temptext", "");
	ontemptext_attrib = custom_page_nonexposed.newAttribute("onTemptext", "0");
	
	dui_comm_attrib = custom_page_nonexposed.newAttribute("DUIComm", "");
	dui_win_main_content_attrib = custom_page_nonexposed.newAttribute("DUIWinMainContent", "");
	dui_win_main2_content_attrib = custom_page_nonexposed.newAttribute("DUIWinMain2Content", "");
	dui_win_side_content_attrib = custom_page_nonexposed.newAttribute("DUIWinSideContent", "");
	dui_win_side2_content_attrib = custom_page_nonexposed.newAttribute("DUIWinSide2Content", "");
	
	genTimerAttrib = custom_page_nonexposed.newAttribute("General Timer", "0");
	dui_last_focus = custom_page_nonexposed.newAttribute("Last Focus", "");
	
	#ifdef MAIN_ATTRIBS_MGR
	
	if (dui_last_focus) dui_last_focus.setData("");
	
	genTimer = new Timer;
	genTimer.setDelay(100);
	genTimer.start();
	
	#endif
}

// -----------------------------------------------------------------------------------------------------------------

#define NOOFF if (getData()=="0") { setData("1"); return; }


Global Int attribs_mychange;

// **** the following function def will be redefined "outside" of attribs.m 
// 	and is called whenever an update to certain attribs happens

boolean onTempText() {
  return ontemptext_attrib.getData()=="0";
}

#ifdef MAIN_ATTRIBS_MGR

// **** GENERAL SYNCHRONIZATION TIMER

genTimer.onTimer() {
	int currDat = stringToInteger(genTimerAttrib.getData());

	currDat++;
	if (currDat > 9) currDat = 0;
	
	genTimerAttrib.setData(integerToString(currDat));
}

Global Timer tempTextDelay = NULL;

temptext_attrib.onDataChanged() {
	if (getData()=="") {
		ontemptext_attrib.setData("0");
		return;
	} else {
		if (!tempTextDelay) {
			tempTextDelay = new Timer;
			tempTextDelay.setDelay(3000);
		}
		tempTextDelay.start();
		ontemptext_attrib.setData("1");
	}
}

tempTextDelay.onTimer() {
	stop();
	temptext_attrib.setData("");
}


//**** NOTIFIER

notifier_always_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_never_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_always_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_minimized_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_always_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_windowshade_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_always_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_topright_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_topleft_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topright_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_bottomright_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_topright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_bottomleft_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_topright_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

#endif

#endif
