/*************************************************************

  mMonkeyEntry - cbutton.m
  by Leechbite

  - this script controls the control buttons (play, pause, etc.)

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

Global group frameGroup;
Global button play, pause, prev, next, stop, open;

System.onScriptLoaded() {
  initAttribs();
  
  frameGroup = getScriptGroup();

  play = findXUIObject(frameGroup,"play","xui.button");
  pause = findXUIObject(frameGroup,"pause","xui.button");
  prev = findXUIObject(frameGroup,"prev","xui.button");
  next = findXUIObject(frameGroup,"next","xui.button");
  stop = findXUIObject(frameGroup,"stop","xui.button");
  open = findXUIObject(frameGroup,"open","xui.button");


  if (System.getStatus() != 1) {
    Play.getParent().show();
    Pause.getParent().hide();
  }
  else {
    Pause.getParent().show();
    Play.getParent().hide();
  }
  
}

system.onScriptUnloading() {
  return;
}

// ********* play2pause scripts **************

System.onPlay()
{
	Pause.getParent().show();
	Play.getParent().hide();

	setTempText("Play");
}

System.onresume()
{
	Pause.getParent().show();
	Play.getParent().hide();
	setTempText("Resume Play");
}

System.onPause()
{
	Play.getParent().show();
	Pause.getParent().hide();
	setTempText("Pause");

}

System.onStop()
{
	Play.getParent().show();
	Pause.getParent().hide();
	setTempText("Stop");
}

Next.onLeftClick() {
   setTempText("Next");
}

Prev.onLeftClick() {
   setTempText("Previous");
}