// ******* Anunaki - Config.m **********

#include <lib/std.mi>
#include <lib/config.mi>
#include "attribs.m"

Global container configcont;
Global layout configLayout;

Global text fadeintext, fadeouttext, staytext;

Global tabsheet configTabs;

System.onScriptLoaded() {
	initAttribs();

	configcont = getContainer("Config");
	configlayout = configcont.getLayout("normal");

	fadeintext = configlayout.findObject("fadein.text");
	fadeouttext = configlayout.findObject("fadeout.text");
	staytext = configlayout.findObject("stay.text");

	notifier_fadeintime_attrib.onDataChanged();
	notifier_fadeouttime_attrib.onDataChanged();
	notifier_holdtime_attrib.onDataChanged();

}

system.onScriptUnloading() {
	return;
}

// *********** notifier scripts ***************

notifier_fadeintime_attrib.onDataChanged() {
	float sec = stringToInteger(getData())/1000;
	
	fadeintext.setText("Fade-in Time ("+floatToString(sec, 1)+" sec ):");
}

notifier_fadeouttime_attrib.onDataChanged() {
	float sec = stringToInteger(getData())/1000;
	
	fadeouttext.setText("Fade-out Time ("+floatToString(sec, 1)+" sec ):");
}

notifier_holdtime_attrib.onDataChanged() {
	float sec = stringToInteger(getData())/1000;
	
	staytext.setText("Hold Time ("+floatToString(sec, 1)+" sec ):");
}