/*************************************************************

  mMonkeyEntry - eqsliders.m
  by Leechbite

  - this script controls the eq sliders.

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

#define EQ_Rock 1,49,29,-39,-55,-27,25,57,69,69,69
#define EQ_Full 1,45,37,1,-51,-35,9,53,69,77,77
#define EQ_Pop 1,-15,29,45,49,33,-11,-19,-19,-15,-15
#define EQ_Soft 1,29,9,-11,-19,-11,25,53,61,69,77
#define EQ_Techno 1,49,37,1,-39,-35,1,49,61,61,57
#define EQ_Reggae 1,1,1,-7,-43,1,41,41,1,1,1
#define EQ_Classical 1,1,1,1,1,1,1,-51,-51,-51,-67
#define EQ_Dance 1,61,45,13,-3,-3,-43,-51,-51,-3,-3
#define EQ_Ska 1,-19,-35,-31,-7,25,37,57,61,69,61
#define EQ_SoftRock 1,25,25,13,-7,-31,-39,-27,-7,17,57
#define EQ_Flat 1,1,1,1,1,1,1,1,1,1,1

function setEQPreset(int preamp, int eq0, int eq1, int eq2, int eq3, 
	int eq4, int eq5, int eq6, int eq7, int eq8, int eq9); 

Global group frameGroup;
Global layout eqLayout;

Global button eqFULL, eqROCK, eqPOP, eqSOFT, eqUSER, eqFLAT;
Global int eqUser0,eqUser1,eqUser2,eqUser3,eqUser4,eqUser5,eqUser6,eqUser7,eqUser8,eqUser9,eqUserPreamp;

Global timer eqUsertimer;
Global boolean eqUserDown;

global ConfigAttribute eq_attach_attrib;

System.onScriptLoaded() {
  initAttribs();
  
  frameGroup = getScriptGroup();
  eqLayout = frameGroup.getParentLayout();
  
  eq_attach_attrib = custom_page_windows.newAttribute("Attach Equalizer window", "1");
  group resizers = eqLayout.findObject("wasabi.frame.resize");
  resizers.hide();
  
  eqFULL = frameGroup.findObject("eq.preset.full");
  eqROCK = frameGroup.findObject("eq.preset.rock");
  eqPOP = frameGroup.findObject("eq.preset.pop");
  eqSOFT = frameGroup.findObject("eq.preset.soft");
  eqUSER = frameGroup.findObject("eq.preset.user");
  eqFLAT = frameGroup.findObject("eq.preset.flat");

  eqUser0 = getPrivateInt(getSkinName(), "User EQ 0", 1);
  eqUser1 = getPrivateInt(getSkinName(), "User EQ 1", 1);
  eqUser2 = getPrivateInt(getSkinName(), "User EQ 2", 1);
  eqUser3 = getPrivateInt(getSkinName(), "User EQ 3", 1);
  eqUser4 = getPrivateInt(getSkinName(), "User EQ 4", 1);
  eqUser5 = getPrivateInt(getSkinName(), "User EQ 5", 1);
  eqUser6 = getPrivateInt(getSkinName(), "User EQ 6", 1);
  eqUser7 = getPrivateInt(getSkinName(), "User EQ 7", 1);
  eqUser8 = getPrivateInt(getSkinName(), "User EQ 8", 1);
  eqUser9 = getPrivateInt(getSkinName(), "User EQ 9", 1);
  eqUserPreamp = getPrivateInt(getSkinName(), "User EQ Preamp", 1);
  
  eqUserTimer = new Timer;
  eqUserTimer.setDelay(750);

}

System.onScriptUnLoading() {
  delete eqUserTimer;
}

eq_attach_attrib.onDataChanged() {
  setPrivateInt(getSkinName(),"EqualizerLast W", 320);
  setPrivateInt(getSkinName(),"EqualizerLast H", 243);
}

setEQPreset(int preamp, int eq0, int eq1, int eq2, int eq3, 
	int eq4, int eq5, int eq6, int eq7, int eq8, int eq9) {

  setEQPreamp(preamp);
  setEQBand(0, eq0);
  setEQBand(1, eq1);
  setEQBand(2, eq2);
  setEQBand(3, eq3);
  setEQBand(4, eq4);
  setEQBand(5, eq5);
  setEQBand(6, eq6);
  setEQBand(7, eq7);
  setEQBand(8, eq8);
  setEQBand(9, eq9);
}

eqFULL.onLeftClick() {
  setEQPreset(EQ_Full);
  setTempText("Equalizer|FULL");
}

eqROCK.onLeftClick() {
  setEQPreset(EQ_Rock);
  setTempText("Equalizer|ROCK");
}

eqPOP.onLeftClick() {
  setEQPreset(EQ_Pop);
  setTempText("Equalizer|POP");
}

eqSOFT.onLeftClick() {
  setEQPreset(EQ_Soft);
  setTempText("Equalizer|SOFT");
}

eqFLAT.onLeftClick() {
  setEQPreset(EQ_Flat);
  setTempText("Equalizer|FLAT");
}

eqUSER.onLeftButtonDown(int x, int y) {
  eqUserTimer.start();
  eqUserDown = TRUE;
}

eqUSER.onLeftButtonUp(int x, int y) {
  if (eqUserTimer.isRunning()) {
    eqUserTimer.stop();
    setEQPreset(eqUserPreamp, eqUser0, eqUser1, eqUser2, eqUser3, eqUser4, eqUser5, eqUser6, eqUser7, eqUser8, eqUser9);
    setTempText("USER");
  }
  eqUserDown = FALSE;
}

eqUserTimer.onTimer() {
  stop();
  eqUserDown = FALSE;

  eqUser0 = getEQBand(0);
  eqUser1 = getEQBand(1);
  eqUser2 = getEQBand(2);
  eqUser3 = getEQBand(3);
  eqUser4 = getEQBand(4);
  eqUser5 = getEQBand(5);
  eqUser6 = getEQBand(6);
  eqUser7 = getEQBand(7);
  eqUser8 = getEQBand(8);
  eqUser9 = getEQBand(9);
  eqUserPreamp = getEQPreamp();

  setPrivateInt(getSkinName(), "User EQ 0", eqUser0);
  setPrivateInt(getSkinName(), "User EQ 1", eqUser1);
  setPrivateInt(getSkinName(), "User EQ 2", eqUser2);
  setPrivateInt(getSkinName(), "User EQ 3", eqUser3);
  setPrivateInt(getSkinName(), "User EQ 4", eqUser4);
  setPrivateInt(getSkinName(), "User EQ 5", eqUser5);
  setPrivateInt(getSkinName(), "User EQ 6", eqUser6);
  setPrivateInt(getSkinName(), "User EQ 7", eqUser7);
  setPrivateInt(getSkinName(), "User EQ 8", eqUser8);
  setPrivateInt(getSkinName(), "User EQ 9", eqUser9);
  setPrivateInt(getSkinName(), "User EQ Preamp", eqUserPreamp);

  setTempText("Equalizer|USER EQ SET");
}