/*************************************************************

  mMonkeyEntry - eqsliders.m
  by Leechbite

  - this script controls the eq sliders.

*************************************************************/

#include <lib/std.mi>

#define PREAMP 10

function changeslider(int band);

Global group frameGroup;
class guiObject eqSlider;
Global eqSlider eqslider1,eqslider2,eqslider3,eqslider4,eqslider5,
		eqslider6,eqslider7,eqslider8,eqslider9,eqslider10,
		eqsliderPA;
Global boolean eqchange;

System.onScriptLoaded() {

  frameGroup = getScriptGroup();

  eqslider1 = frameGroup.findObject("eq.slider.base.1");
  eqslider2 = frameGroup.findObject("eq.slider.base.2");
  eqslider3 = frameGroup.findObject("eq.slider.base.3");
  eqslider4 = frameGroup.findObject("eq.slider.base.4");
  eqslider5 = frameGroup.findObject("eq.slider.base.5");
  eqslider6 = frameGroup.findObject("eq.slider.base.6");
  eqslider7 = frameGroup.findObject("eq.slider.base.7");
  eqslider8 = frameGroup.findObject("eq.slider.base.8");
  eqslider9 = frameGroup.findObject("eq.slider.base.9");
  eqslider10 = frameGroup.findObject("eq.slider.base.10");
  eqsliderPA = frameGroup.findObject("eq.slider.base.pre");

  int x;
  for (x=0; x<=10; x++)
    changeslider(x);
}

system.onEQBandChanged(int band, int newvalue) {
  changeslider(band);
}

system.onEQPreampChanged(int newvalue) {
  changeslider(PREAMP);
}

changeslider(int band) {
  string bandstr;
  int bandval;

  if (band==PREAMP) {
    bandstr = "pre";
    bandval = getEQPreamp();
  } else {
    bandstr = integertoString(band+1);
    bandval = getEQBand(band);
  }

  guiObject eqbase = frameGroup.findObject("eq.slider.base."+bandstr);
  guiObject eqfill = frameGroup.findObject("eq.slider.fill."+bandstr);

  int sliderHeight = 100*(127+bandval)/255;
  
  eqfill.setXMLParam("h", integerToString(sliderHeight));
  eqfill.setXMLParam("y", integerToString(100-sliderHeight));
}

eqSlider.onLeftButtonDown(int x, int y) {
  eqchange = 1;
}

eqSlider.onMouseMove(int x, int y) {
  if (eqchange) {
    string bandstr = gettoken(getID(), ".", 3);

    if (bandstr=="pre") {
      setEQPreamp(127-254*(y-getTop())/getHeight());
    } else {
      setEQBand(stringtoInteger(bandstr)-1,127-254*(y-getTop())/getHeight());
    }
  }
}

eqSlider.onLeftButtonUp(int x, int y) {
  if (eqchange) {
    string bandstr = gettoken(getID(), ".", 3);

    if (bandstr=="pre") {
      setEQPreamp(127-254*(y-getTop())/getHeight());
    } else {
      setEQBand(stringtoInteger(bandstr)-1,127-254*(y-getTop())/getHeight());
    }
  }
  eqchange = 0;
}