/*************************************************************

  mMonkeyEntry - main.m
  by Leechbite

  - this script controls main window. some scripts that dont
    have a place on any of the other scripts. :D

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

Global layout mainLayout;
Global group duiMainWindow, duiSideWindow;
Global group compToggle1, compToggle2;

Global group rsxGroup;

Global button fullscreen, restore;
Global group groupResizer, groupMove;

Global string min_w, min_h;


System.onScriptLoaded() {
  initAttribs();
  
  container main = getContainer("main");
  mainLayout = main.getLayout("normal");
  
  duiMainWindow = mainLayout.findObject("dui.main");
  duiSideWindow = mainLayout.findObject("dui.side");
  
  compToggle1 = mainLayout.findObject("main.components");
  compToggle2 = mainLayout.findObject("main.components.2");
  
  group temp = mainLayout.findObject("fullscreen");
  fullscreen = temp.getObject("xui.button");
  temp = mainLayout.findObject("restore");
  restore = temp.getObject("xui.button");
  groupResizer = mainLayout.findObject("wasabi.frame.resize");
  groupMove = mainLayout.findObject("wasabi.frame.move");

  min_w = mainLayout.getXMLParam("minimum_w");
  min_h = mainLayout.getXMLParam("minimum_h");
  
  rsxGroup = mainLayout.findObject("main.rsx");
  
  if (!duiMainWindow.isVisible() && !duiSideWindow.isVisible()) {
    compToggle1.hide();
    compToggle2.show();
    fullscreen.getParent().hide();
    restore.getParent().hide();
  } else {
    compToggle1.show();
    compToggle2.hide();
    if (!restore.getParent().isVisible() && !fullscreen.getParent().isVisible()) {
      fullscreen.getParent().show();
      restore.getParent().hide();
    }
  }
}

system.onScriptUnLoading() {
 if (restore.getParent().isVisible()) restore.onLeftClick();
}

fullscreen.onLeftClick() {
  int vp_x = getViewPortLeft();
  int vp_y = getViewPortTop();
  int vp_w = getViewPortWidth();
  int vp_h = getViewPortHeight();
  
  setPrivateInt(getSkinName(), "restore_x", mainLayout.getLeft());
  setPrivateInt(getSkinName(), "restore_y", mainLayout.getTop());
  setPrivateInt(getSkinName(), "restore_w", mainLayout.getWidth());
  setPrivateInt(getSkinName(), "restore_h", mainLayout.getHeight());
  
  mainLayout.setXMLParam("minimum_w",integerToString(vp_w));
  mainLayout.setXMLParam("minimum_h",integerToString(vp_h));
  
  mainLayout.resize(vp_x, vp_y, vp_w, vp_h);
  groupResizer.hide();
  groupMove.hide();
  
  fullscreen.getParent().hide();
  restore.getParent().show();
}

restore.onLeftClick() {

  mainLayout.setXMLParam("minimum_w",min_w);
  mainLayout.setXMLParam("minimum_h",min_h);
  
  mainLayout.resize(getPrivateInt(getSkinName(), "restore_x", 0), 
  					getPrivateInt(getSkinName(), "restore_y", 0), 
  					getPrivateInt(getSkinName(), "restore_w", 400), 
  					getPrivateInt(getSkinName(), "restore_h", 300));
  groupResizer.show();
  groupMove.show();
  
  fullscreen.getParent().show();
  restore.getParent().hide();
}

mainLayout.onResize(int x, int y, int w, int h) {
  if (w < 500) {
    rsxGroup.hide();
  } else {
    rsxGroup.show();
  }
}

duiMainWindow.onSetVisible(boolean on) {
  if (!on && !duiSideWindow.isVisible()) {
    compToggle1.hide();
    compToggle2.show();
    if (restore.getParent().isVisible()) restore.onLeftClick();
    fullscreen.getParent().hide();
    restore.getParent().hide();
  } else {
    compToggle1.show();
    compToggle2.hide();
    if (!restore.getParent().isVisible() && !fullscreen.getParent().isVisible()) {
      fullscreen.getParent().show();
      restore.getParent().hide();
    }
  }
}

duiSideWindow.onSetVisible(boolean on) {
  duiMainWindow.onSetVisible(duiMainWindow.isVisible());
}

System.onScriptUnLoading() {
  return;
}
