/*************************************************************

  seeker.m
  by Leechbite

  Controls the seeker mainly the temptext.

*************************************************************/


#define ENABLE_TEMPTEXT

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

function updateseeker(int x);

Global group frameGroup;
Global slider realSlider;
Global boolean seekChanging = 0;
Global int w;

System.onScriptLoaded() {
  initAttribs();

  frameGroup = getScriptGroup();

  realSlider = frameGroup.getObject("xui.slider");

}

System.onScriptUnloading() {
  return;
}

realSlider.onLeftButtonDown(int x, int y) {
  if (getPlayItemLength() > 0) { 
    SeekChanging = 1;
    updateSeeker(x);
  }
}

realSlider.onLeftButtonUp(int x, int y) {
  float l;
  if (SeekChanging) {

    int p = x - realSlider.getLeft();
    w = realSlider.getWidth();
    if (p > w) p=w;
    if (p < 0) p=0;
    l = p*255/w;

    if (l >= 0) {
      if (System.getPlayItemLength() >= 0) {
        l = l * System.getPlayItemLength()/255;
      }
    }
    SeekChanging = 0;
  }
}

realSlider.onMouseMove(int x, int y) {
	if (SeekChanging) {
		updateSeeker(x);
	}
}

updateSeeker(int x) {

	int p = x - realSlider.getLeft();
	w = realSlider.getWidth();
	if (p > w) p=w;
	if (p < 0) p=0;
	if (p >= 0) {

		float len = System.getPlayItemLength();
		int s = (p * len) / w;
		setTempText("Seek|" + integerToTime(s) + " / " + integerToTime(len) + " ("+integerToString(p*100/w)+"%)");
	}
}