/*************************************************************

  mMonkey - togglebuttons.m
  by Leechbite

  - this script controls the repeat,shuffle,xfade temp text
    display

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

Global group frameGroup;
Global togglebutton buttonSHF, buttonXFD;
Global button buttonREP;
Global slider Xfdtime;

Global configAttribute attrRepeat,attrXfadetime;

System.onScriptLoaded() {
  initAttribs();

  frameGroup = getScriptGroup();

  buttonSHF = frameGroup.findObject("Shuffle");
  buttonREP = frameGroup.findObject("Repeat");
  buttonXFD = frameGroup.findObject("Xfade");
  
  configItem item = Config.getItem("Playlist editor");
  attrRepeat = item.getAttribute("repeat");
  
  configItem item = Config.getItemByGuid("{F1239F09-8CC6-4081-8519-C2AE99FCB14C}");
  attrXfadetime = item.getAttribute("Crossfade time");

}

system.onScriptUnloading() {
  XfdTime = NULL;
}

buttonSHF.onToggle(int on) {
  if (on==1) {
    setTempText("Shuffle On");
  } else {
    setTempText("Shuffle Off");
  }
}

buttonREP.onLeftClick() {
  int v = stringToInteger(attrRepeat.getData());
  v++;
  
  if (v>1) v = -1;
  
  attrRepeat.setData(integerToString(v));
}

attrRepeat.onDataChanged() {
  string v = getData();
  if (v=="0") setTempText("Repeat Off");
  else if (v=="1") setTempText("Repeat All");
  else setTempText("Repeat Track");
}

buttonXFD.onActivate(int on) {
  if (on==1) {
    setTempText("Crossfading On");
  } else {
    setTempText("Crossfading Off");
  }
}

buttonREP.onRightButtonDown(int x, int y) {
  popUpMenu repmenu = new popUpMenu;

  int x;
  int repeatmode = stringToInteger(attrRepeat.getData());

  repmenu.addCommand("- Repeat -", -1, 0, 1);
  repmenu.addSeparator();
  repmenu.addCommand("Repeat Off", 0, (repeatmode==0), 0);
  repmenu.addCommand("Repeat All", 1, (repeatmode==1), 0);
  repmenu.addCommand("Repeat Track", 2, (repeatmode==-1), 0);

  int res = repmenu.popAtMouse();
  delete repmenu;

  complete;

  if (res<0) return;
  if (res==2) res = -1;

  attrRepeat.setData(integerToString(res));
}

buttonXFD.onRightButtonDown(int x, int y) {
  popUpMenu xfdmenu = new popUpMenu;

  int x;
  int currFadetime = stringToInteger(attrXfadetime.getData());
  boolean XfadeOn = buttonXFD.getActivated()==1;

  xfdmenu.addCommand("- Xfade Time -", -1, 0, 1);
  xfdmenu.addSeparator();
  xfdmenu.addCommand("Off", 0, (currFadetime==0) || (!XfadeOn), 0);

  for (x=1; x<=20; x++) {
    xfdmenu.addCommand(integerToString(x)+" sec", x, (currFadetime==x) && (XfadeOn), 0);
  }

  int res = xfdmenu.popAtMouse();
  delete xfdmenu;

  complete;

  if (res<0) return;
  if (res==0) {
    if (XFadeOn) buttonXFD.leftClick();
  }
  else {
    if (!XFadeOn) buttonXFD.leftClick();
    attrXfadetime.setData(integerToString(res));
  }
}

attrXfadetime.onDataChanged() {
  setTempText("Crossfade Time| "+getData()+" sec");
}