/*** 

	Utilities.m - common functions used by most scripts.

***/

#define TRUE 1
#define FALSE 0

function centerObject(guiObject obj, boolean centx, boolean centy);
function guiObject findXUIObject(group parentGroup, string id, string xuiID);

// centers guiobjects depending on parent group/layout
centerObject(guiObject obj, boolean centx, boolean centy) {

  guiObject _parentobj = obj.getParent();

  int x, y;

  if (centx) {
    x = (_parentobj.getWidth() - obj.getWidth())/2;
    if (x < 0) x = 0;
  } else
    x = obj.getGuiX();
  if (centy) {
    y = (_parentobj.getHeight() - obj.getHeight())/2;
    if (y < 0) y = 0;
  } else
    y = obj.getGuiY();

  obj.setXMLParam("x", integerToString(x));
  obj.setXMLParam("y", integerToString(y));

}

guiObject findXUIObject(group parentGroup, string id, string xuiID) {
  group _XUIGroup = parentGroup.findObject(id);
  if (_XUIGroup) 
    guiObject _retObj = _XUIGroup.findObject(xuiID);
  
  return _retObj;
}

#ifdef __ATTRIBS_M

function setTempText(string t);

setTempText(string t) {
  temptext_attrib.setData(t);
}

#endif