/*************************************************************

  mMonkeyEntry - xui-button.m
  by Leechbite

  XMLButton XUI Object Scripts

  parameters:

  	normalGroup - group id button's normal state
    downGroup - group id down state
    hoverGroup - group id hover state

*************************************************************/

#include <lib/std.mi>

Global group ButtonGroup;
Global string idNormal, idDown, idHover, idActive;
Global button realButton;
Global guiobject buttonGroups;
Global boolean mouseOver;

System.onScriptLoaded() {
  ButtonGroup = getScriptGroup();

  realButton = buttonGroup.getObject("xui.button");
  buttonGroups = buttonGroup.getObject("button.groups");

  mouseOver = 0;
  
  realButton.setXMLParam("ghost", buttonGroup.getXMLParam("ghost"));    

  realButton.onActivate(0);
}

System.onScriptUnloading() {
  realButton = NULL;  // clears all events
  buttonGroup = NULL;
}

realButton.onLeftButtonDown(int x, int y) {
  buttonGroups.setXMLParam("groupid",idDown);
}

realButton.onLeftButtonUp(int x, int y) {
  if (mouseOver)
    buttonGroups.setXMLParam("groupid",idHover);
  else {
    if (realButton.getActivated()==1) 
      buttonGroups.setXMLParam("groupid",idActive);
    else 
      buttonGroups.setXMLParam("groupid",idNormal);
  }
}

realButton.onEnterArea() {
  mouseOver = 1;

  buttonGroups.setXMLParam("groupid",idHover);
}

realButton.onLeaveArea() {
  mouseOver = 0;

  if (realButton.getActivated()==1) 
    buttonGroups.setXMLParam("groupid",idActive);
  else 
    buttonGroups.setXMLParam("groupid",idNormal);
}

realButton.onActivate(int on) {
  if (realButton.getActivated()==1) 
    buttonGroups.setXMLParam("groupid",idActive);
  else 
    buttonGroups.setXMLParam("groupid",idNormal);
}

System.onSetXuiParam(String param, String value) {
  param = system.strlower(param);
  if (param=="normalgroup") {
    idNormal = value;
    buttonGroups.setXMLParam("groupid",idNormal);
  } else if (param=="downgroup") {
    idDown = value;
  } else if (param=="hovergroup") {
    idHover = value;
  } else if (param=="activegroup") {
    idActive = value;
  } else if (param=="tips") {
	realButton.setXMLParam("tooltip",value);
  } else {
    realButton.setXMLParam(param,value);
  }
  
  
  
  if (idDown == "") idDown = idNormal;
  if (idHover == "") idHover = idNormal;
  if (idActive == "") idActive = idNormal;
  
  //realButton.onActivate(0);
}