/*************************************************************

  mMonkeyEntry - xui-levelsliderh.m
  by Leechbite

  XMLLevelSliderH XUI Object Scripts

  parameters:

		color - RGB color of level
		bkcolor - background color
		levelAlpha - alpha of main level
		bkAlpha - alpha of background
		tips - tooltips

*************************************************************/

#include <lib/std.mi>

Global group sliderGroup;
Global slider realSlider;
Global guiObject rectBk, rectLv;

System.onScriptLoaded() {
  sliderGroup = getScriptGroup();

  realSlider = sliderGroup.getObject("xui.slider");
  rectBk = sliderGroup.getObject("bkground");
  rectLv = sliderGroup.getObject("level");
  realSlider.setXMLParam("action","seek");
}

System.onScriptUnloading() {
  realSlider = NULL;  // clears all events
}

realSlider.onSetPosition(int newpos) {
  rectLv.setXMLParam("w", integerToString(sliderGroup.getWidth()*newpos/255));
}

realSlider.onPostedPosition(int newpos) {
  realSlider.onSetPosition(newpos);
}

sliderGroup.onResize(int x, int y, int w, int h) {
  realSlider.setPosition(realSlider.getPosition());
}

System.onSetXuiParam(String param, String value) {
  param = system.strlower(param);
  if (param=="color") {
    rectLv.setXMLParam("color",value);
  } else if (param=="bkcolor") {
    rectBk.setXMLParam("color",value);
  } else if (param=="levelalpha") {
    rectLv.setAlpha(stringToInteger(value));
  } else if (param=="bkalpha") {
	rectBk.setAlpha(stringToInteger(value));
  } else if (param=="tips") {
	realSlider.setXMLParam("tooltip",value);
  } else {
    realSlider.setXMLParam("action","seek");
  }
}